%% TODO

%close all;
clear all;
col{1} = [.4 .4 .4];
col{2} = [.7 .7 .7];
col{3} = [.2 .2 .2];
col{4} = [.5 .5 .5];
col{5} = [.2 .2 .2];
col{6} = [.6 .6 .6];

dsymb = 2;

% load files
algs = {'QL', 'QL', 'QL', 'QL', 'VI', 'SQL'};
algs_str={'QL (\omega=0.51)', 'QL (\omega=0.60)','QL (\omega=0.80)', 'QL (\omega=1.00)', 'VI', 'SQL' };

omegas = {'0.51', '0.60', '0.80', '1.00'};
bench = {'Lin', 'CombLock', 'Grid'};

bench_str = {'Linear', 'Combination lock', 'Grid world'};

for a = 1:numel(algs)
    for b = 1:numel(bench)
        switch a
            case 1
                fdata = ['test_' algs{a} '1_' bench{b} '_omega' omegas{1} '.mat'];
                %fcpu = ['test_' algs{a} '_cpu8_' bench{b} '_omega' omegas{1} '.mat'];
                fprintf('QL 0.51\t%s\t',bench{b});
            case 2
                fdata = ['test_' algs{a} '1_' bench{b} '_omega' omegas{2} '.mat'];
                %fcpu = ['test_' algs{a} '_cpu8_' bench{b} '_omega' omegas{2} '.mat'];
                fprintf('QL 0.6\t%s\t',bench{b});
            case 3
                fdata = ['test_' algs{a} '1_' bench{b} '_omega' omegas{3} '.mat'];
                %fcpu = ['test_' algs{a} '_cpu8_' bench{b} '_omega' omegas{3} '.mat'];
                fprintf('QL 0.8\t%s\t',bench{b});
            case 4
                fdata = ['test_' algs{a} '1_' bench{b} '_omega' omegas{4} '.mat'];
                %fcpu = ['test_' algs{a} '_cpu8_' bench{b} '_omega' omegas{3} '.mat'];
                fprintf('QL 1\t%s\t',bench{b});
            otherwise
                fdata = ['test_' algs{a} '1_' bench{b} '.mat'];
                %fcpu = ['test_' algs{a} '_cpu8_' bench{b} '.mat'];
                fprintf('%s\t%s\t',algs{a},bench{b});
        end
        data{a,b} = load(fdata);
        cpu{a,b} = load(fdata);
        
        if b==3
            limit=60;
        else
            limit=30;
        end
        mcpu = median(data{a,b}.vcpuMat,2);
        idx_above = find(mcpu>limit,1,'first');
        if ~isempty(idx_above)
            if abs(limit-mcpu(idx_above-1)) < abs(limit-mcpu(idx_above))
                idxerr = idx_above-1;
            else
                idxerr = idx_above;
            end
        else
            idxerr = numel(mcpu);
        end
        fprintf('%.2f (%.2f)\n', data{a,b}.meanSupErr(idxerr), data{a,b}.stdSupErr(idxerr));
    end
end

% VI hak
cpu{4,1}.vcpuMat(end,:)=30;

vmark0 = {'>--', '^--', '<--', 'o--', '*-','.-'};
vmark1 = {'--', '--', '--', '--', '-','-'};
vmark2 = {'>', '^', '<', 'o', '*','.'};
%vcolor = {[.6 .6 .6], [.3 .3 .3], [0 0 0], 'k', 'k'};
vcolor = {'k', 'k','k', 'k','k', 'k'};
xlims = [30, 30, 60];

best_eta_apl = [3 2 3];
best_eta_fqi = [2 1 1];
smth = 0.001;
maxit = 5e3;

miny = 1e1;
maxy = 2.2e3;

% FINAL PLOT
hn=figure(1); clf;
%set(hn,'PaperType','A4');
%set(hn,'PaperOrientation','landscape');
%set(hn,'PaperUnits','centimeters');
%set(hn,'PaperPosition',[0 0 25 15]);

fontsize = 16;
linewidth=1.6;

% just for legend
for i=1:3
    for a = 1:numel(algs)
        subplot(1,3,i);
        if a==6
            plot(-1, -1, vmark0{a}, 'color', vcolor{a}, 'linewidth', linewidth, 'markersize', 15);
        else
            plot(-1, -1, vmark0{a}, 'color', vcolor{a}, 'linewidth', linewidth, 'markersize', 8);
        end
        hold on;
    end
end

for i=1:3
    for a = 1:numel(algs)
        subplot(1,3,i);
        xaxis = median( cpu{a,i}.vcpuMat , 2);
        yaxis = data{a,i}.meanSupErr(1,:,4);
        if a==6
            plot(xaxis, yaxis, vmark1{a}, 'color', vcolor{a}, 'linewidth', linewidth);
            plot(xaxis(3:dsymb:end), yaxis(3:dsymb:end), vmark2{a}, 'linewidth', linewidth, 'color', vcolor{a}, 'markersize', 15);
        else
            if a==5
                plot(xaxis, yaxis, vmark1{a}, 'color', vcolor{a}, 'linewidth', linewidth);
                plot(xaxis(2:end), yaxis(2:end), vmark2{a}, 'linewidth', linewidth, 'color', vcolor{a}, 'markersize', 8);
            else
                plot(xaxis, yaxis, vmark1{a}, 'color', vcolor{a}, 'linewidth', linewidth);
                plot(xaxis(3:dsymb:end), yaxis(3:dsymb:end), vmark2{a}, 'linewidth', linewidth, 'color', vcolor{a}, 'markersize', 8);
            end;
        end
        set(gca,'yscale','log');
        grid on;
        set(gca, 'yminorgrid', 'off');
        axis tight;
        set(gca, 'xlim', [0 xlims(i)]);
        if i==3
            set(gca, 'ylim', [miny maxy]);
        elseif i==2
            set(gca, 'ylim', [miny maxy]);
        else
            set(gca, 'ylim', [miny maxy]);
        end
    end
    title(bench_str{i}, 'FontSize', fontsize);
    xlabel('CPU time (sec)', 'FontSize', fontsize);
    set(gca, 'FontSize', fontsize);
    if i==1
        ylabel('Loss', 'FontSize', fontsize);
    end
end
for i=1:3
    subplot(1,3,i);
    pos = get(gca,'position');
    set(gca,'position',[pos(1)-(i-1)*.03 pos(2) pos(3) pos(4)]);
end

h=legend(algs_str{1},algs_str{2},algs_str{3}, algs_str{4},algs_str{5},algs_str{6});
set(h, 'FontSize', fontsize);
pos = get(h,'position');
set(h, 'position', [pos(1)+0.25 pos(2) pos(3) pos(4)]);

saveas(hn, '~/MatlabWorkspace/SQLTest/SQL_Res_beta1000.pdf');
