function testQLASync(omega, kind, version)


% eval(['mex -lgsl -lgslcblas -lm ../ql' num2str(version) '.cpp']);
% mex -lgsl -lgslcblas -lm ../ql_dummy.cpp

%close all
%load RobotModel
%load RobotModelBig

gammaVect=[0.5,.9,0.99,0.999];% 0.8, 0.82 , 0.84, 0.86, 0.88, 0.9 ,0.92 , 0.94, 0.96, 0.98, 0.995];
%gammaVect=0.95;
gVectSz=length(gammaVect);
%omega=0.51;

tol=1e-4;
tryNum=50;
%tryNum=5;

%sampNum=50e6;
eval(['load ' kind '_Mdl']);
sampNum=2e5*MDP.SSz*MDP.S(1).ASz;
%eval(['load ' kind 'MedMdl']);
%%%%Initialization
%QOpt=QOptEst(MDP,tol,gamma);

%% call mex file
params.dt = 9;
%params.dt =1;
params.tol = tol;
params.sampNum = sampNum;
params.tryNum = tryNum;
params.omega = omega;
MDPC=[MDP.S.A];
params.rMax = max(abs([MDPC.r]));
supErrMat = zeros(tryNum , params.dt+2 , gVectSz);
vcpuMat= zeros( params.dt+2 , gVectSz );


for j=1:gVectSz
    params.gamma = gammaVect(j);
%    eval(['[QN QO vit vcpu superr] = ql' num2str(version) '(params,MDP);']);
    eval(['[QN QO vit vcpu] = qlASync' num2str(version) '(params,MDP);']);
    vcpuMat(:,j)=mean(vcpu);
    for k=1:tryNum
        for i=1:params.dt+2
            %QPi  = QPolEst( QN(k,i).Q,  MDP , PMat, r,  gammaVect(j), tol  );
            supErrMat(k,i,j)=max(abs(QN(k,i).Q(:)-QO(:)));
        end;
    end;
end;

%disp('[Running dummy QL]');
%disp('------------------');
%[QN_ QO_ vit_ vcpu_dummy] = QL_dummy(params,MDP);

meanSupErr = mean(supErrMat,1);
stdSupErr  =  std(supErrMat,1,1);

fileout = sprintf('test_QLASync%d_%s_omega%.2f.mat', version, kind, omega);
disp(['Saving ' fileout]);
%save(fileout, 'meanSupErr', 'stdSupErr', 'vcpu', 'vit', 'vcpu_dummy');
save(fileout, 'meanSupErr', 'stdSupErr','vcpuMat', 'vit', 'gammaVect');

