function testSQLSync(kind, version)


%eval(['mex -I/usr/local/include -lgsl -lgslcblas -lm ../DPP' num2str(version) '.cpp']);
%mex -I/usr/local/include -lgsl -lgslcblas -lm ../DPP_dummy.cpp

%close all
%load RobotModel
%load RobotModelBig
gammaVect=[0.5,0.9,0.99,0.999];%[ 0.8, 0.82 , 0.84, 0.86, 0.88, 0.9 ,0.92 , 0.94, 0.96, 0.98, 0.995];
%gammaVect=[ 0.8,  0.99];
gVectSz=length(gammaVect);
%gamma=0.9;

tol=1e-4;
%tryNum=50;
tryNum=50;
sampNum=1e5;
%sampNum=1e3;
eval(['load ' kind '_Mdl']);
%eval(['load ' kind 'MedMdl']);
%eval(['load ' kind 'MedMdl']);
%%%%Initialization

%QOpt=QOptEst(MDP,tol,gamma);


%% call mex file
params.dt =9;
params.tol = tol;
params.sampNum = sampNum;
params.tryNum = tryNum;

MDPC=[MDP.S.A];
params.rMax = max(abs([MDPC.r]));
supErrMat = zeros( tryNum , params.dt+2 , gVectSz );
vcpuMat= zeros( params.dt+2 , gVectSz );

for j=1:gVectSz
    params.gamma = gammaVect(j);
    %eval(['[QN QO vit vcpu superr] = DPP' num2str(version) '(params,MDP);']);
    eval(['[QN QO vit vcpu] = SQL' num2str(version) '(params,MDP);']);
    vcpuMat(:,j)=mean(vcpu);
    for k=1:tryNum
         for i=1:params.dt+2
             %QPi  = QPolEst( QN(k,i).Q,  MDP , PMat, r,  gammaVect(j) ,tol  );
             supErrMat(k,i,j)=max( abs( QN(k,i).Q(:) - QO(:) ));
         end;
     end;
end;

%disp('[Running dummy DPP ]');
%disp('--------------------');
%[QN_ QO_ vit_ vcpu_dummy] = DPP_dummy(params,MDP);

meanSupErr =  mean(supErrMat,1);
stdSupErr  =  std(supErrMat,1,1);

fileout = sprintf('test_SQL%d_%s.mat', version, kind);
disp(['Saving ' fileout]);
%save(fileout, 'vcpu', 'vit', 'vcpu_dummy', 'superr');
%save(fileout, 'meanSupErr', 'stdSupErr', 'vcpu', 'vit', 'vcpu_dummy');
save(fileout, 'meanSupErr', 'stdSupErr', 'vcpuMat', 'vit', 'gammaVect');

